/* 
 * Copyright (c) 2012 Qualcomm Atheros, Inc.. 
 * All Rights Reserved. 
 * Qualcomm Atheros Confidential and Proprietary. 
 */

/* create form list */
function createFormList(id, actionUrl, checkFun, button)
{
  this.id = id;
  this.divId = id + 'Div';

  /* list parameters */
  this.listId = id + 'List';
  this.titleArr;
  this.rowArr = new Array();
  this.rowNum = 0;
  this.colNum = 0;
  this.cellArr = new Array();
  this.cellNum = 0;
  this.colAttribute = new Array();
  this.maxColNum = 0;

  /* form parameters */
  this.formId = id+'Form';
  this.actionUrl = actionUrl;
  this.checkFun = checkFun;
  this.sendArr = new Array();
  this.sendNum = 0;
  this.needSent = false;
  this.button = button;
  this.hiddenArr = new Array();
  this.hiddenNum = 0;
  this.hiddenArr[this.hiddenNum++] = ['submitId', id];

  this.defineTitle = function(titleEntry)
  {
    this.titleArr = titleEntry.split('?');
  }

  this.defineColAttribute = function(colAttribute)
  {
    this.colAttribute = colAttribute;
  }

  this.defineCellStr = function(str)
  {
    this.cellArr[this.cellNum++] = ['str', str];
  }

  this.defineCellInputStr = function(value, objId, title, mustSet, spaceValid, size, min, max)
  {
    /* inputStr define: [0]'inputStr', [1]value, [2]objId, [3]title, [4]mustSet, [5]spaceValid, [6]size, [7]min, [8]max */
    this.cellArr[this.cellNum++] = ['inputStr', value, objId, title, mustSet, spaceValid, size, min, max];
  }

  this.defineCellSelect = function(value, objId, title, mustSet, size, displayOptionList, valueOptionList, onChangeFun)
  {
    /* select define: [0]'select', [1]value, [2]objId, [3]title, [4]mustSet, [5]size, [6]displayOptionList, [7]valueOptionList, [8]onChangeFun */
    this.cellArr[this.cellNum++] = ['select', value, objId, title, mustSet, size, displayOptionList, valueOptionList, onChangeFun];
  }

  this.defineCellInputIp = function(value, objId, title, mustSet, size, nullVaild, allZeroValid)
  {
    /* inputIp define: [0]'inputIp', [1]value, [2]objId, [3]title, [4]mustSet, [5]size, [6]nullVaild, [7]allZeroValid */
    this.cellArr[this.cellNum++] = ['inputIp', value, objId, title, mustSet, size, nullVaild, allZeroValid];
  }

  this.defineCellCheckBox = function(value, objId, title, mustSet, description, onChangeFun)
  {
    /* checkBox define: [0]'checkBox', [1]value, [2]objId, [3]title, [4]mustSet, [5]description, [6]onChangeFun */
    this.cellArr[this.cellNum++] = ['checkBox', value, objId, title, mustSet, description, onChangeFun];
  }

  this.defineCellInputNum = function(value, objId, title, mustSet, nullValid, size, min, max)
  {
    /* inputNum define: [0]'inputNum', [1]value, [2]objId, [3]title, [4]mustSet, [5]null valid, [6]size, [7]min, [8]max */
    this.cellArr[this.cellNum++] = ['inputNum', value, objId, title, mustSet, nullValid, size, min, max];
  }

  this.defineCellInputPwd = function(value, objId, title, mustSet, spaceValid, size, min, max)
  {
    /* inputPwd define: [0]'inputPwd', [1]value, [2]objId, [3]title, [4]mustSet, [5]spaceValid, [6]size, [7]min, [8]max */
    this.cellArr[this.cellNum++] = ['inputPwd', value, objId, title, mustSet, spaceValid, size, min, max];
  }
  
  this.defineCellInputMac = function(value, objId, title, mustSet, size, nullVaild, mcastValid)
  {
    /* inputMac define: [0]'inputMac', [1]value, [2]objId, [3]title, [4]mustSet, [5]size, [6]nullVaild, [7]mcastValid*/
    this.cellArr[this.cellNum++] = ['inputMac', value, objId, title, mustSet, size, nullVaild, mcastValid];
  }

  this.defineCellInputOui = function(value, objId, title, mustSet, size, nullVaild)
  {
    /* inputOui define: [0]'inputOui', [1]value, [2]objId, [3]title, [4]mustSet, [5]size, [6]nullVaild */
    this.cellArr[this.cellNum++] = ['inputOui', value, objId, title, mustSet, size, nullVaild];
  }
  
  this.defineCellInputIpv6 = function(value, objId, title, mustSet, size, nullVaild, allZeroValid)
  {
    /* inputIp define: [0]'inputIp', [1]value, [2]objId, [3]title, [4]mustSet, [5]size, [6]nullVaild, [7]allZeroValid */
    this.cellArr[this.cellNum++] = ['inputIpv6', value, objId, title, mustSet, size, nullVaild, allZeroValid];
  }

    
  this.defineRow = function()
  {
    this.rowArr[this.rowNum++] = this.cellArr;
    if (this.colNum < this.cellNum)
    {
      this.colNum = this.cellNum;
    }
    this.cellNum = 0;
    this.cellArr = new Array();
  }

  this.alertAllRows = function()
  {
    var str = 'this.colAttribute='+this.colAttribute+'\n';
    str += 'this.rowNum='+this.rowNum+'\n';
    str += 'this.colNum='+this.colNum+'\n';

    for (i=0;i<this.rowNum;i++)
    {
      for (j=0;j<this.colNum;j++)
      {
        if (this.rowArr[i][j] != undefined)
        {
          str += 'this.rowArr['+i+']['+j+']='+this.rowArr[i][j]+'\n';
        }
      }
    }

    alert(str);
  }

  this.drawTitle = function()
  {
  }

  this.drawDiv = function()
  {
    return '<div id="' + this.divId + '"><\/div>';
  }

  this.drawList = function()
  {
    var str = '';

    /* draw list */
    str += '<table class="data" id="'+ this.listId +'">';

    /* tr loop */
    for (var k = 0; this.rowArr[k] != null; k++)
    {
      str += '<tr id="'+this.listId+'_tr'+k+'">';

      /* td loop */
      for (var l = 0; this.rowArr[k][l] != null; l++)
      {
        if (this.colAttribute[l][0] == 'th')
        {
          str += '<th id="'+this.listId+'_tr'+k+'_th'+l+'"';
          var endStr = '<\/th>';
        }
        else
        {
          str += '<td id="'+this.listId+'_tr'+k+'_td'+l+'"';
          var endStr = '<\/td>';
        }

        if (this.colAttribute[l][1] != '')
        {
          str += ' width="'+ this.colAttribute[l][1] +'"';
        }

        str += '>';

        /* switch type */
        switch (this.rowArr[k][l][0])
        {
          case 'str' :
            /* str define: [0]'str', [1]value */
            str += this.rowArr[k][l][1];
            break;
          case 'inputStr' :
            /* inputStr define: [0]'inputStr', [1]value, [2]objId, [3]title, [4]mustSet, [5]spaceValid, [6]size, [7]min, [8]max */
            str += drawInputStr(this.rowArr[k][l][2], this.rowArr[k][l][6], this.rowArr[k][l][8], this.rowArr[k][l][1]);
            break;
          case 'select' :
            /* select define: [0]'select', [1]value, [2]objId, [3]title, [4]mustSet, [5]size, [6]displayOptionList, [7]valueOptionList, [8]onChangeFun */
            str += drawSelect(this.rowArr[k][l][2], this.rowArr[k][l][5], this.rowArr[k][l][6], this.rowArr[k][l][7], this.rowArr[k][l][1], this.rowArr[k][l][8]);
            break;
          case 'inputIp' :
           /* inputIp define: [0]'inputIp', [1]value, [2]objId, [3]title, [4]mustSet, [5]size, [6]nullVaild, [7]allZeroValid */
            str += drawInputIp(this.rowArr[k][l][2], this.rowArr[k][l][5], this.rowArr[k][l][1]);
            break;
          case 'inputMac' :
            /* inputMac define: [0]'inputMac', [1]value, [2]objId, [3]title, [4]mustSet, [5]size, [6]nullVaild, [7]mcastValid*/
            str += drawInputMac(this.rowArr[k][l][2], this.rowArr[k][l][5], this.rowArr[k][l][1]);
            break;
          case 'checkBox' :
            /* checkBox define: [0]'checkBox', [1]value, [2]objId, [3]title, [4]mustSet, [5]description, [6]onChangeFun */
            str += drawCheckBox(this.rowArr[k][l][2], this.rowArr[k][l][5], this.rowArr[k][l][1], this.rowArr[k][l][6]);
            break;
          case 'inputNum' :
            /* inputNum define: [0]'inputNum', [1]value, [2]objId, [3]title, [4]mustSet, [5]null valid, [6]size, [7]min, [8]max */
            str += drawInputNum(this.rowArr[k][l][2], this.rowArr[k][l][6], this.rowArr[k][l][8], this.rowArr[k][l][1]);
            break;
          case 'inputPwd' :
            /* inputPwd define: [0]'inputPwd', [1]value, [2]objId, [3]title, [4]mustSet, [5]spaceValid, [6]size, [7]min, [8]max */
            str += drawInputPwd(this.rowArr[k][l][2], this.rowArr[k][l][6], this.rowArr[k][l][8], this.rowArr[k][l][1]);
            break;
          case 'inputOui' :
           /* inputOui define: [0]'inputOui', [1]value, [2]objId, [3]title, [4]mustSet, [5]size, [6]nullVaild */
            str += drawInputOui(this.rowArr[k][l][2], this.rowArr[k][l][5], this.rowArr[k][l][1]);
            break;
          case 'inputIpv6' :
           /* inputOui define: [0]'inputOui', [1]value, [2]objId, [3]title, [4]mustSet, [5]size, [6]nullVaild */
            str += drawInputIpv6(this.rowArr[k][l][2], this.rowArr[k][l][5], this.rowArr[k][l][1]);
            break;
        }

        str += endStr;
      }

      str += '<\/tr>';
    }

    str += '<\/table>';

    return str;
  }

  this.drawButton = function()
  {
    return drawButtons(this.id, this.button);
  }

  this.submitForm = function()
  {
    submitForm(this);
  }

  this.clearSendArr = function()
  {
    //this.sendArr = new Array();
    this.sendNum = 0;
    this.needSent = false;
  }

  this.checkList = function()
  {
    var changeNum = 0;

    for (var row = 0; this.rowArr[row] != null; row++)
    {
      for (var col = 0; this.rowArr[row][col] != null; col++)
      {
        var obj = mainIframe.document.getElementById(this.rowArr[row][col][2]);

        if ((obj != null) && (obj.disabled == false))
        {
          var message = '';
          var mustSet = false;
          var isChange = false;

          switch (this.rowArr[row][col][0])
          {
            case 'str' :
              break;

            case 'inputStr' :
              /* inputStr define: [0]'inputStr', [1]value, [2]objId, [3]title, [4]mustSet, [5]spaceValid, [6]size, [7]min, [8]max */
              /* function checkInputkStr(title, str, min, max, spaceVaild) */
              message = checkInputStr(this.rowArr[row][col][3], obj.value, this.rowArr[row][col][7], this.rowArr[row][col][8], this.rowArr[row][col][5]);
              mustSet = this.rowArr[row][col][4];

              if (obj.value != this.rowArr[row][col][1])
              {
                isChange = true;
                changeNum ++;
              }
              break;

            case 'select' :
              /* select define: [0]'select', [1]value, [2]objId, [3]title, [4]mustSet, [5]size, [6]displayOptionList, [7]valueOptionList, [8]onChangeFun */
              mustSet = this.rowArr[row][col][4];
              
              if (!this.rowArr[row][col][6])
              {
              	message = "please select an item.";              	
              }

              if (obj.value != this.rowArr[row][col][1])
              {
                isChange = true;
                changeNum ++;
              }
              break;

            case 'inputIp' :
              /* inputIp define: [0]'inputIp', [1]value, [2]objId, [3]title, [4]mustSet, [5]size, [6]nullVaild, [7]allZeroValid */
              mustSet = this.rowArr[row][col][4];

              /* if can't be null or have input value, check input value */
              if ((this.rowArr[row][col][6] == false) || (obj.value != ''))
                message = checkInputIp(this.rowArr[row][col][3], obj.value, this.rowArr[row][col][7]);

              if (obj.value != this.rowArr[row][col][1])
              {
                isChange = true;
                changeNum ++;
              }
              break;

            case 'inputMac' :
              /* inputMac define: [0]'inputMac', [1]value, [2]objId, [3]title, [4]mustSet, [5]size, [6]nullVaild, [7]mcastValid*/
              mustSet = this.rowArr[row][col][4];

              /* if can't be null or have input value, check input value */
              if ((this.rowArr[row][col][6] == false) || (obj.value != ''))
                message = checkInputMac(this.rowArr[row][col][3], obj.value, this.rowArr[row][col][6], this.rowArr[row][col][7]);

              if (obj.value != this.rowArr[row][col][1])
              {
                isChange = true;
                changeNum ++;
              }
              break;
            
			case 'checkBox' :
              /* checkBox define: [0]'checkBox', [1]value, [2]objId, [3]title, [4]mustSet, [5]description, [6]onChangeFun */
              mustSet = this.rowArr[row][col][4];

              if (obj.checked == true)
                obj.value = 1;
              else
                obj.value = 0;

              if (obj.value != this.rowArr[row][col][1])
              {
                isChange = true;
                changeNum ++;
              }
              break;

            case 'inputNum' :
              /* inputNum define: [0]'inputNum', [1]value, [2]objId, [3]title, [4]mustSet, [5]null valid, [6]size, [7]min, [8]max */
              /* function checkInputkNum(title, str, min, max, nullVaild) */
              message = checkInputNum(this.rowArr[row][col][3], obj.value, this.rowArr[row][col][7], this.rowArr[row][col][8], this.rowArr[row][col][5]);
              mustSet = this.rowArr[row][col][4];

              if (obj.value != this.rowArr[row][col][1])
              {
                isChange = true;
                changeNum ++;
              }
              break;

            case 'inputPwd' :
              /* inputPwd define: [0]'inputPwd', [1]value, [2]objId, [3]title, [4]mustSet, [5]spaceValid, [6]size, [7]min, [8]max */
              /* function checkInputkPwd(title, pwd, min, max, spaceVaild) */
              message = checkInputkPwd(this.rowArr[row][col][3], obj.value, this.rowArr[row][col][7], this.rowArr[row][col][8], this.rowArr[row][col][5]);
              mustSet = this.rowArr[row][col][4];

              if (obj.value != this.rowArr[row][col][1])
              {
                isChange = true;
                changeNum ++;
              }
              break;
              
            case 'inputOui' :
              /* inputOui define: [0]'inputOui', [1]value, [2]objId, [3]title, [4]mustSet, [5]size, [6]nullVaild */
              mustSet = this.rowArr[row][col][4];

              /* if can't be null or have input value, check input value */
              if ((this.rowArr[row][col][6] == false) || (obj.value != ''))
                message = checkInputOui(this.rowArr[row][col][3], obj.value, this.rowArr[row][col][6]);

              if (obj.value != this.rowArr[row][col][1])
              {
                isChange = true;
                changeNum ++;
              }
              break;

            case 'inputIpv6' :
              /* inputIp define: [0]'inputIp', [1]value, [2]objId, [3]title, [4]mustSet, [5]size, [6]nullVaild, [7]allZeroValid */
              mustSet = this.rowArr[row][col][4];

              /* if can't be null or have input value, check input value */
              if ((this.rowArr[row][col][6] == false) || (obj.value != ''))
                message = checkInputIpv6(this.rowArr[row][col][3], obj.value, this.rowArr[row][col][7]);

              if (obj.value != this.rowArr[row][col][1])
              {
                isChange = true;
                changeNum ++;
              }
              break;

          }

          /* check fail */
          if (message != '')
          {
            alert(message);
            obj.focus();
            return false;
          }

          if ((isChange == true) || (mustSet == true))
          {
            /* save obj id and value to send*/
            this.sendArr[this.sendNum++] = [this.rowArr[row][col][2], obj.value];
          }
        }
      }
    }

    /* check need sent */
    if (changeNum != 0 || this.sendNum > 1)
    {
      this.needSent = true;
    }

    return true;
  }

  this.checkNeedSent = function()
  {
    if (this.needSent == false)
    {
      alert('Configuration not be changed.');
      return false;
    }

    return true;
  }

}

